// BonSrcDecoder.h: CBonSrcDecoder NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once


#include "MediaDecoder.h"
#include "IBonDriver.h"
#include "IBonDriver2.h"
#include "TsUtilClass.h"


// G[R[h
#define BSDEC_NOERROR			0x00000000UL	// G[Ȃ
#define BSDEC_TUNERERROR		0x00000001UL	// `[iG[
#define BSDEC_INTERNALERROR		0x00000002UL	// G[
#define BSDEC_TUNERNOTOPEN		0x00000003UL	// `[iɕĂ
#define BSDEC_ALREADYOPEN		0x00000004UL	// `[iɊJĂ
#define BSDEC_ALREADYPLAYING	0x00000005UL	// ɍĐĂ
#define BSDEC_NOTPLAYING		0x00000006UL	// ĐĂȂ
#define BSDEC_DRIVERERROR		0x00000007UL	// hCoG[


/////////////////////////////////////////////////////////////////////////////
// Bon\[XfR[_(`[iTSXg[M)
/////////////////////////////////////////////////////////////////////////////
// Output	#0	: CMediaData		TSXg[
/////////////////////////////////////////////////////////////////////////////

class CBonSrcDecoder : public CMediaDecoder  
{
public:
	CBonSrcDecoder(IEventHandler *pEventHandler = NULL);
	virtual ~CBonSrcDecoder();

// IMediaDecoder
	virtual void Reset(void);
	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0UL);

// CBonSrcDecoder
	const bool OpenTuner(HMODULE hBonDrvDll);
	const bool CloseTuner(void);

	const bool Play(void);
	const bool Stop(void);

	const bool SetChannel(const BYTE byChannel);
	const bool SetChannel(const DWORD dwSpace, const DWORD dwChannel);
	const float GetSignalLevel(void);

	const bool IsBonDriver2(void) const;
	LPCTSTR GetSpaceName(const DWORD dwSpace) const;
	LPCTSTR GetChannelName(const DWORD dwSpace, const DWORD dwChannel) const;

	const DWORD GetLastError(void) const;

	// Append by HDUSTest̒̐l
	int NumSpaces() const;
	LPCTSTR GetTunerName() const;
	DWORD GetBitRate() const;
protected:
	const bool PurgeStream(void);
	virtual void OnTsStream(BYTE *pStreamData, DWORD dwStreamSize);

	bool BeginStreamRecvThread();
	bool EndStreamRecvThread();
	void ResetBitRate();

	CMediaData m_TsStream;

	CCriticalLock m_CriticalLock;
	bool m_bIsPlaying;
	DWORD m_dwLastError;

	DWORD m_BitRateTime;
	DWORD m_BitRate;
private:
	static DWORD WINAPI StreamRecvThread(LPVOID pParam);

	IBonDriver *m_pBonDriver;
	IBonDriver2 *m_pBonDriver2;	
	
	HANDLE m_hStreamRecvThread;
	HANDLE m_hKillEvent;
};
