#ifndef CHANNEL_MANAGER_H
#define CHANNEL_MANAGER_H


#include "ChannelList.h"


class CChannelManager {
	int m_CurrentSpace;
	int m_CurrentChannel;
	int m_ChangingChannel;
	CChannelList m_AllChannelList;
	CTuningSpaceList m_TuningSpaceList;
	bool m_fNetworkRemocon;
	const CChannelList *m_pNetworkRemoconChannelList;
	int m_NetworkRemoconCurrentChannel;
public:
	enum {
		SPACE_INVALID=-2,
		SPACE_ALL=-1
	};
	CChannelManager();
	~CChannelManager();
	bool LoadChannelList(LPCTSTR pszFileName,CBonSrcDecoder *pSrcDecoder);
	bool MakeTuningSpaceList(int NumSpaces);
	bool ReserveTuningSpaceList(int NumSpaces);
	int GetCurrentChannel() const { return m_CurrentChannel; }
	int GetCurrentSpace() const { return m_CurrentSpace; }
	bool SetCurrentSpace(int Space);
	bool SetCurrentChannel(int Channel);
	bool SetChangingChannel(int Channel);
	const CChannelInfo *GetCurrentChannelInfo() const;
	const CChannelInfo *GetChangingChannelInfo() const;
	const CChannelInfo *GetNextChannelInfo(bool fNext) const;
	const CChannelList *GetCurrentChannelList() const;
	CChannelList *GetChannelList(int Space);
	CChannelList *GetAllChannelList();
	int FindChannelInfo(const CChannelInfo *pInfo) const;
	int NumSpaces() const;
	bool SetNetworkRemoconMode(bool fNetworkRemocon,const CChannelList *pList=NULL);
	int GetNetworkRemoconCurrentChannel() const { return m_NetworkRemoconCurrentChannel; }
	bool SetNetworkRemoconCurrentChannel(int Channel);
};


#endif
