#include "StdAfx.h"
#include "EnumFilter.h"

CDirectShowUtil::CDirectShowUtil(void)
	: m_FilterClassID()
{
	CoInitialize(NULL);
}

CDirectShowUtil::~CDirectShowUtil(void)
{
	CoUninitialize();
}

void CDirectShowUtil::Clear()
{
	m_FilterClassID.RemoveAll();
}

int CDirectShowUtil::GetFilterCount()
{
	return m_FilterClassID.GetCount();
}

bool CDirectShowUtil::GetFilterInfo(const int iIndex,CLSID *pidClass,CStringW *pFriendryName)
{
	if(iIndex<0||iIndex>=GetFilterCount()) return false;
	DIRECTSHOW_FILTER_INFO &item = m_FilterClassID.GetAt(iIndex);
	if(pidClass) *pidClass = item.class_id;
	if(pFriendryName) *pFriendryName = item.friendry_name;
	return true;
}

bool CDirectShowUtil::FindFilter(const CLSID *pidInType,const CLSID *pidInSubType,const CLSID *pidOutType,const CLSID *pidOutSubType)
{
	// idType idSubType ̃tB^(ϊtB^)
	bool bRet = false;
	IFilterMapper2 *pMapper=NULL;
	HRESULT hr=CoCreateInstance(CLSID_FilterMapper2,NULL, CLSCTX_INPROC, IID_IFilterMapper2,(void **) &pMapper);	
	if(SUCCEEDED(hr)) {
		IEnumMoniker *pEnum=NULL;
		GUID arInType[2],arOutType[2];
		GUID *pInTypes,*pOutTypes;
		if(pidInType)    arInType[0] = *pidInType;
		if(pidInSubType) arInType[1] = *pidInSubType;
		pInTypes = (pidInType && pidInSubType) ? arInType : NULL;
		if(pidOutType)   arOutType[0] = *pidOutType;
		if(pidOutSubType)arOutType[1] = *pidOutSubType;
		pOutTypes = (pidOutType && pidOutSubType) ? arOutType : NULL;

		hr = pMapper->EnumMatchingFilters(
			&pEnum,
			0,					// \ς
			TRUE,				// Svgp邩
			MERIT_DO_NOT_USE+1,	// ŏ̃bg
			TRUE,				// 1 ȏ̓̓s?
			pInTypes?1:0,		// ͂̃W[^Cv/Tu^Cv̑΂̐
			pInTypes,			// ͂̃W[^Cv/Tu^Cv̑΂̔z
			NULL,				// ̓fBA
			NULL,				// ̓s̃JeS
			FALSE,				// _łȂ΂ȂȂ
			TRUE,				// 1 ȏ̏o̓s
			pOutTypes?1:0,		// o͂̃W[^Cv/Tu^Cv̑΂̐
			pOutTypes,			// o͂̃W[^Cv/Tu^Cv̑΂̔z
			NULL,				// o̓fBA
			NULL);				// o̓s̃JeS
		if(SUCCEEDED(hr)){
			IMoniker *pMoniker;
			ULONG cFetched;
			while(pEnum->Next(1, &pMoniker, &cFetched) == S_OK){
				IPropertyBag *pPropBag;
				hr=pMoniker->BindToStorage(0, 0, IID_IPropertyBag, (void **)&pPropBag);
				if(SUCCEEDED(hr)){
					VARIANT varName,varID;
					VariantInit(&varName);
					VariantInit(&varID);
					hr=pPropBag->Read(L"FriendlyName", &varName, 0);
					if(SUCCEEDED(hr)){
						hr=pPropBag->Read(L"CLSID", &varID, 0);
						if(SUCCEEDED(hr)){
							bRet = true;
							DIRECTSHOW_FILTER_INFO stInfo;
							stInfo.friendry_name = varName.bstrVal;
							CLSIDFromString(varID.bstrVal,&stInfo.class_id);
							m_FilterClassID.Add(stInfo);
							SysFreeString(varID.bstrVal);
							}
							SysFreeString(varName.bstrVal);
						}
						pPropBag->Release();
					}
				}
				pEnum->Release();
			}
			pMapper->Release();
		}
	return bRet;
}

// tB^w胁fBÃs
IPin* CDirectShowUtil::GetFilterPin(IBaseFilter *pFilter,const PIN_DIRECTION dir,const AM_MEDIA_TYPE *pMediaType)
{
	IEnumPins *pEnumPins=NULL;
	IPin *pPin;
	IPin *pRetPin=NULL;
	int dbgRef;

	if(pFilter->EnumPins(&pEnumPins)==S_OK ){
		ULONG cFetched;
		while(!pRetPin&&pEnumPins->Next(1,&pPin,&cFetched)==S_OK){
			PIN_INFO stPin;
			if(pPin->QueryPinInfo(&stPin)==S_OK){
				if(stPin.dir==dir){
					if(!pMediaType){
						// ĂOK
						pRetPin=pPin;
						dbgRef=pRetPin->AddRef();
						} else {
						// DirectShowɂ܂ăs
						if(pPin->QueryAccept(pMediaType)==S_OK){
							pRetPin=pPin;
							dbgRef=pRetPin->AddRef();
							}	
						}
					}
				}
				dbgRef=pPin->Release();
			}
		dbgRef=pEnumPins->Release();
		}
	return pRetPin;
}