// DtvEngine.h: CDtvEngine NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once


#include "BonSrcDecoder.h"
#include "TsPacketParser.h"
#include "TsDescrambler.h"
#include "ProgManager.h"
#include "MediaViewer.h"
#include "MediaTee.h"
#include "FileWriter.h"
#include "FileReader.h"

#include "../Tracer.h"

// ̕ӂ͑S̎bł


//////////////////////////////////////////////////////////////////////
// fW^TVGWNX
//////////////////////////////////////////////////////////////////////

class CDtvEngineHandler;

class CDtvEngine : protected CMediaDecoder::IEventHandler
{
public:
	enum EVENTID
	{
		EID_SERVICE_LIST_UPDATED,	// T[rXXgXV
		EID_SERVICE_INFO_UPDATED,	// T[rXXV
		EID_PCR_TIMESTAMP_UPDATED	// PCR^CX^vXV(Ȃp)
	};

	CDtvEngine(void);
	~CDtvEngine(void);

	const bool BuildEngine(CDtvEngineHandler *pDtvEngineHandler,
				HWND hHostHwnd,HWND hMessageDrainHwnd,bool bDescramble=true,
												LPCWSTR pszMpeg2Decoder=NULL);
	const bool IsEngineBuild() { return m_bBuiled; };
	const bool CloseEngine(void);
	const bool ResetEngine(void);

	const bool OpenSrcFilter_BonDriver(HMODULE hBonDriverDll);
	const bool OpenSrcFilter_File(LPCTSTR lpszFileName);
	const bool ReleaseSrcFilter();

	const bool EnablePreview(const bool bEnable = true);
	const bool SetViewSize(const int x,const int y);
	const bool SetVolume(const float fVolume);
	const bool GetVideoSize(WORD *pwWidth,WORD *pwHeight);
	const bool GetVideoAspectRatio(BYTE *pbyAspectRateX,BYTE *pbyAspectRateY);
	const BYTE GetAudioCahnnelNum();
	const bool SetStereoMode(int iMode);
	const bool GetVideoDecorderName(LPWSTR lpName,int iBufLen);
	const bool DisplayVideoDecorderProperty(HWND hWndParent);

	const bool SetChannel(const BYTE byTuningSpace, const WORD wChannel);
	const bool SetService(const WORD wService);
	const WORD GetService(void) const;
	const unsigned __int64 GetPcrTimeStamp() const;

	/*
	const bool PlayFile(LPCTSTR lpszFileName);
	void StopFile(void);
	*/

	const DWORD GetLastError(void) const;

	// Append by HDUSTest̒̐l
	bool GetOriginalVideoSize(WORD *pWidth,WORD *pHeight) const;
	CEpgDataInfo *GetEpgDataInfo(WORD wSID, bool bNext);
	bool SetTracer(CTracer *pTracer);

//protected:
	const DWORD SendDtvEngineEvent(const DWORD dwEventID, PVOID pParam = NULL);
	virtual const DWORD OnDecoderEvent(CMediaDecoder *pDecoder, const DWORD dwEventID, PVOID pParam);

	// IMediaDecoder hfBAfR[_NX
	CBonSrcDecoder m_BonSrcDecoder;			// TS\[X`[i[(HALׂ)
	CTsPacketParser m_TsPacketParser;		// TSpPb^CU[
	CTsDescrambler m_TsDescrambler;			// TSfXNu[
	CProgManager m_ProgManager;				// TSvO}l[W[
	CMediaViewer m_MediaViewer;				// fBAr[A[
	CMediaTee m_MediaTee;					// fBAeB[
	CFileWriter m_FileWriter;				// t@CC^[
	CFileReader m_FileReader;				// t@C[_[

	CDtvEngineHandler *m_pDtvEngineHandler;
	WORD m_wCurTransportStream;
	WORD m_wCurService;
	WORD m_wCurVideoPID;
	WORD m_wCurAudioPID;
	unsigned __int64 m_u64CurPcrTimeStamp;

	bool m_bBuiled;
	bool m_bIsFileMode;

	// Append by HDUSTest̒̐l
	CTracer *m_pTracer;
	void Trace(LPCTSTR pszOutput, ...);
};


//////////////////////////////////////////////////////////////////////
// fW^TVCxgnhC^tF[X
//////////////////////////////////////////////////////////////////////

// ͏z֐Ƃׂ
class CDtvEngineHandler
{
friend CDtvEngine;

protected:
	virtual const DWORD OnDtvEngineEvent(CDtvEngine *pEngine, const DWORD dwEventID, PVOID pParam);
};
