#ifndef EPG_PROGRAM_LIST
#define EPG_PROGRAM_LIST


/*
	قƂTSEpgView_SimplẽR[h̗p
	ꂩ|[eBO\
*/


#include <vector>
#include <map>
#include "Epg.h"


struct SERVICE_INFO_DATA{
	WORD wOriginalNID;
	WORD wTSID;
	WORD wServiceID;
	CString strServiceName;
	WORD wServiceType;
	SERVICE_INFO_DATA & operator= (const SERVICE_INFO_DATA & o) {
		wOriginalNID = o.wOriginalNID;
		wTSID = o.wTSID;
		wServiceID = o.wServiceID;
		strServiceName = o.strServiceName;
		wServiceType = o.wServiceType;
		return *this;
	};
};

struct NIBBLE_DATA{
	unsigned char ucContentNibbleLv1; //content_nibble_level_1
	unsigned char ucContentNibbleLv2; //content_nibble_level_2
	unsigned char ucUserNibbleLv1; //user_nibble
	unsigned char ucUserNibbleLv2; //user_nibble
	NIBBLE_DATA & operator= (const NIBBLE_DATA & o) {
		ucContentNibbleLv1 = o.ucContentNibbleLv1;
		ucContentNibbleLv2 = o.ucContentNibbleLv2;
		ucUserNibbleLv1 = o.ucUserNibbleLv1;
		ucUserNibbleLv2 = o.ucUserNibbleLv2;
		return *this;
	};
};

struct EVENT_INFO_DATA{
	WORD wOriginalNID;
	WORD wTSID;
	WORD wServiceID;
	WORD wEventID;
	CString strEventName;
	CString strEventText;
	CString strEventExtText;
	SYSTEMTIME stStartTime;
	DWORD dwDurationSec;
	unsigned char ucComponentType;
	CString strComponentTypeText;
	unsigned char ucAudioComponentType;
	unsigned char ucESMultiLangFlag;
	unsigned char ucMainComponentFlag;
	unsigned char ucSamplingRate;
	CString strAudioComponentTypeText;
	std::vector<NIBBLE_DATA> NibbleList;
	EVENT_INFO_DATA & operator= (const EVENT_INFO_DATA & o) {
		wOriginalNID = o.wOriginalNID;
		wTSID = o.wTSID;
		wServiceID = o.wServiceID;
		wEventID = o.wEventID;
		strEventName = o.strEventName;
		strEventText = o.strEventText;
		strEventExtText = o.strEventExtText;
		stStartTime = o.stStartTime;
		dwDurationSec = o.dwDurationSec;
		ucComponentType = o.ucComponentType;
		strComponentTypeText = o.strComponentTypeText;
		ucAudioComponentType = o.ucAudioComponentType;
		ucESMultiLangFlag = o.ucESMultiLangFlag;
		ucMainComponentFlag = o.ucMainComponentFlag;
		ucSamplingRate = o.ucSamplingRate;
		strAudioComponentTypeText = o.strAudioComponentTypeText;
		NibbleList = o.NibbleList;
		return *this;
	};
};

struct EVENT_INFO_LIST {
	std::map<WORD, EVENT_INFO_DATA> EventDataMap; //L[ EventID
	EVENT_INFO_LIST & operator= (const EVENT_INFO_LIST & o) {
		EventDataMap = o.EventDataMap;
		return *this;
	};
};

class CEpgProgramList {
	CEpgDataCapDllUtil *m_pEpgDll;
public:
	typedef std::map<ULONGLONG,SERVICE_INFO_DATA>::iterator ServiceIterator;
	typedef std::map<ULONGLONG,EVENT_INFO_LIST>::iterator EventListIterator;
	typedef std::map<WORD,EVENT_INFO_DATA>::iterator EventIterator;
	std::map<ULONGLONG,SERVICE_INFO_DATA> ServiceMap;
	std::map<ULONGLONG,EVENT_INFO_LIST> EventMap;
	CEpgProgramList();
	~CEpgProgramList();
	void SetEpgDataCapDllUtil(CEpgDataCapDllUtil *pEpgDll) { m_pEpgDll=pEpgDll; }
	bool UpdateProgramList();
	void Clear();
};


#endif
